import React from "react";
import ProfileView from "./profileView";
import Weather from "./weather";


class LoggedView extends React.Component {

    constructor(props){
        super(props)
        this.state = {
          currentView: "weather",
          token: "NULL",
          profile: null,
          msg: ""
        }
    
    }

    changeView = (view) => {
        this.setState({
          currentView: view
        })
    }

    currentView = () => {
    

        switch(this.state.currentView) {
          case "weather":
            return (
                <React.Fragment>
                    <Weather token={this.props.token} />
                    <a onClick={ () => this.changeView("profile")} href="#" >Profile</a>
                </React.Fragment>
            );
            break;
          case "profile": 
            return (
                <React.Fragment>
                    <ProfileView token={this.props.token} profile={this.props.profile} />
                    <a onClick={ () => this.changeView("weather")} href="#">Weather</a>
                </React.Fragment>
            );
            break;
          default:
            break;
        }
    }
    

    render() {
        return (
          <React.Fragment>
            {this.currentView()}
            <a href='/'>Logout</a>
          </React.Fragment>
        )
      }

}


export default LoggedView;