import React from "react";
import sha256 from 'crypto-js/sha256';

const host = 'http://'+ process.env.REACT_APP_API_HOST;


class ProfileView extends React.Component {


    constructor(props){
        super(props)
        this.state = {
          token: props.token,
          profile: props.profile,
          msg: ""
        }
    
      }

    hash = (string) => {
        const hash = sha256(string).toString();
    
        return hash.toUpperCase();
      }

    loggedSubmit = (method, pwd, details = '', status = '') => {
        console.log("Method:" + method  + ", token:"+this.props.token);
    
        let url = host + '/api/profiles/'+ this.props.profile.id_key;
        
    
        var myHeaders = new Headers();
            myHeaders.append("Content-Type", "application/json");
            
            myHeaders.append("Accept", "application/json");
            myHeaders.append("Connection", "keep-alive");
            myHeaders.append("token", this.props.token);
    
        var raw = null;
        if (method==='PUT') {
            raw = JSON.stringify({
                "details": details,
                "status": status,
                "isActive": 1,
                "password":  this.hash(pwd)
              });
        }
        var requestOptions = {
            method: method,
            headers: myHeaders,
            body: raw,
            redirect: 'follow'
            };
    
    
        console.log("Calling url "+method+": "+ url);
        fetch(url, 
                requestOptions)
                .then((response) => {
                    if (response.status === 204) {
                        return;
                    } else if (response.ok) {
                        return response.json();
                    } else {
                        console.log('warning', 'Not auhorized');
                        
                        throw Error;
                    }
                })
                .then((result) => {
                    
                    if (method === 'GET') {
                        console.log('result:'+result);
                        console.log("GET profile="+ result.toString());
                        this.setState({
                            token: this.state.token,
                            profile: result,
                            msg: 'Refreshed'
                        });
                    } else if (method==='DELETE') {
                        this.setState({
                            token: null,
                            profile: null,
                            msg: 'Deleted'
                        });
                      } else if (method==='PUT') {
                        
                        this.setState({
                          token: this.state.token,
                          profile: {
                            "id_key": this.state.profile.id_key,
                            "isactive": 1,
                            "details": details,
                            "status": status,
                            "username": this.state.profile.username
                          },
                          msg: 'User Updated'
                        });

                      }
                })
                .catch((error) => {
                    console.log('error', error);
                    //this.state.msg= 'Not auhorized';
                    this.setState({
                        token: this.state.token,
                        profile: this.state.profile,
                        msg: 'Not auhorized'
                    });
                });
      }

    render() {
            if (this.state.profile && Object.keys(this.state.profile).length>0) {
                return (
                    <ProfileAction token={this.props.token} profile={this.state.profile} handleSubmit={this.loggedSubmit}/>
                );
            } else {
                return (
                    <h2>User Deleted</h2>
                );
            }
    }
}

class ProfileAction extends React.Component {

    handleSubmit = (event) => {
        event.preventDefault();
        if (event.target.password) {
            const met= event.target.metode.value;
            const pwd = event.target.password.value;
            const details2 = event.target.details.value;
            
            //this.loggedSubmit(met, pwd, details2, '');

            this.props.handleSubmit(met, pwd, details2, '');
            
        } else {
            console.log("password invalid or undefined");
        }
      }

    render() {
        try {
            return (
                <form onSubmit={this.handleSubmit}>
                  <input type="hidden" id="id" name="id" value={this.props.profile.id_key} />
                  <input type="hidden" id="method" name="method" value="GET" />
                <h2>Hello </h2>
                <fieldset>
                  <legend>User {this.props.profile.username}</legend>
                  <ul>
                    <li>
                      
                      <label htmlFor="username">Username: {this.props.profile.username}</label>
  
                    </li>
                    <li>
                      <label htmlFor='details'>Details: {this.props.profile.details}</label>
                      <input type="text" id="details" name="details" maxLength="256" />
                    </li>
                    <li>
                      <label htmlFor="password">Password:</label>
                      <input type="password" id="password" name="password" maxLength="64" />                
                    </li>
                    <li>
                      <label htmlFor="metode"> ACTION </label>
                      <input type="radio" id="methodGET" name="metode" value="GET" defaultChecked /><label htmlFor="methodGET">Refresh</label>
                      <input type="radio" id="methodPUT" name="metode" value="PUT"/><label htmlFor="methodPUT">Update</label>
                      <input type="radio" id="methodDEL" name="metode" value="DELETE" /><label htmlFor="methodDEL">Delete</label>
                
                    </li>
                  </ul>
                </fieldset>
                <button type="submit" >SUBMIT</button>
              </form>
          )
              
        } catch (error) {
            console.error('Error loading Logged ProfileView, ', error);
        } 
    }
}

export default ProfileView;