-- SEQUENCE: public.user_id_key_seq
DROP TABLE public.user_profile;
DROP SEQUENCE public.user_id_key_seq;

CREATE SEQUENCE public.user_id_key_seq
    INCREMENT 1
    START 1
    MINVALUE 1
    MAXVALUE 9223372036854775807
    CACHE 1;

-- Table: public.user_profile

--DROP TABLE public.user_profile;

CREATE TABLE public.user_profile
(
    id_key bigint NOT NULL DEFAULT nextval('user_id_key_seq'::regclass),
    created_date timestamp without time zone NOT NULL DEFAULT now(),
    username text NOT NULL COLLATE pg_catalog."default",
    details text COLLATE pg_catalog."default",
    isactive integer NOT NULL DEFAULT 1,
    isadmin integer NOT NULL DEFAULT 0,
    status text COLLATE pg_catalog."default",
    pwd_sha256 text NOT NULL COLLATE pg_catalog."default",
    PRIMARY KEY (id_key)
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

-- Index: user_profile_idx

-- DROP INDEX public.user_profile_idx;

CREATE INDEX user_profile_idx
    ON public.user_profile USING btree
    (username COLLATE pg_catalog."default" ASC NULLS LAST)
    TABLESPACE pg_default;

INSERT INTO public.user_profile (username, details, isactive, isadmin, pwd_sha256)
VALUES ('admin', 'Adminsitrator', 1, 1, '1CD2C893AFE3DF45B66C9D03431B5F7086967A3ABCB1190247ABDF2E72897B21');

INSERT INTO public.user_profile (username, details, isactive, isadmin, pwd_sha256)
VALUES ('user', 'Sample user', 1, 0, '5E884898DA28047151D0E56F8DC6292773603D0D6AABBDD62A11EF721D1542D8');